设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 99|回复: 0

[源码] 【布局】删除模型空间视口外的所有实体

[复制链接]

签到天数: 1141 天

连续签到: 35 天

[LV.10]以坛为家III

已领礼包: 40个

财富等级: 招财进宝

发表于 2017-12-27 18:24:21 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
本帖最后由 newer 于 2017-12-27 18:26 编辑

拾取视口,视口内的实体保留,模型空间其他实体全部删除。

  1. (defun c:tt ()
  2.   (if (setq e (car (xdrx_entsel
  3.                      "\n拾取视口<退出>:"
  4.                      '((0 . "viewport"))
  5.                    )
  6.               )
  7.       )
  8.     (progn
  9.       (setq verts (xdrx_getpropertyvalue e "vertices")) ;视口4个角点
  10.       (setq mat-ps2ms (xdrx_matrix_ps2ms e));图纸空间视口到模型空间的变换矩阵
  11.       (vl-cmdf "mspace");进入视口的模型空间
  12.       (setq verts (xdrx_points_transform verts mat-ps2ms));矩阵作用,得到模型空间对应窗口的四个角点
  13.       (if (and (setq ss (ssget "cp" verts));;CP选择集(窗口内)
  14.                (setq ss1 (ssget "x" '((410 . "Model"))));模型空间所有实体选择集
  15.                (setq ss (xdrx_pickset_subtract ss1 ss)));选择集差,得到窗口外的实体选择集
  16.         (progn
  17.           (xdrx_entity_delete ss);删除
  18.         )
  19.       )
  20.       (vl-cmdf "pspace");回到视口外
  21.     )
  22.   )
  23.   (princ)
  24. )

上面代码改改,就是 布局生成单独的DWG。


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2018-10-20 11:51 , Processed in 0.112169 second(s), 17 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

© 2001-2017 Comsenz Inc.

快速回复 返回顶部 返回列表